package MV;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;

import java.awt.event.*;

import java.io.*;

import java.util.*;

import javax.swing.JDialog.*;

import javax.swing.border.*;

import java.lang.*;



public class Bond

{

	String type;

	NewAtom Atom1;

	NewAtom Atom2;	

	

	Bond( String type )

	{

		this.type = type;

	}	

	

	Bond( String type, NewAtom Atom1, NewAtom Atom2  )

	{

		this.type = type;

		this.Atom1 = Atom1;

		this.Atom2 = Atom2;

	}

	

	public void setAtom1(NewAtom Atom1)

	{

		this.Atom1 = Atom1; 

	}

	

	public void setAtom2(NewAtom Atom2)

	{

		this.Atom2 = Atom2;

	}

		

	public NewAtom getAtom1()

	{

		return Atom1;

	}

	

	public NewAtom getAtom2()

	{

		return Atom2;

	}		

	

	public void Draw( Graphics g )

	{

		Color c;

		if( type.equals("Single Bond") )

			c = Color.white;

		else if( type.equals("Double Bond") )

			c = Color.red;

		else 

			c = Color.blue;		

		g.setColor(c);

		int x1 = Atom1.getX() , x2 = Atom2.getX();

		int y1 = Atom1.getY() , y2 = Atom2.getY(); 

		

		g.drawLine(x1-1,y1,x2-1,y2);

		g.drawLine(x1,y1,x2,y2);

		g.drawLine(x1+1,y1,x2+1,y2);

		g.drawLine(x1,y1-1,x2,y2-1);

		g.drawLine(x1,y1+1,x2,y2+1);

	}

	

	public String getType()

	{

		return type; 

	}	

	

}		

		