package MV;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;

import java.awt.event.*;

import java.io.*;

import java.util.*;

import javax.swing.border.*;

import java.lang.*;

import java.io.*;



class DrawMolecule

{

	int color_var,yoffset,r;

	int atomCount,count,bondCount;

	Color color;

	Cord center;

	MyDrawPanel drawPanel;

	Graphics g, newG;

	double i,j;

	Vector atom,Pos;  

	String Molecule;      		

	boolean check;

	Atom temp;

	Image myImage;

	Vector bonds;

	MyBond myBond;

	int x,y;

	int rMax;	



	public DrawMolecule( MyDrawPanel drawPanel, String Molecule ,int x,int y)

	{

		this.x = x;

		this.y = y;

		this.Molecule = Molecule;

		this.drawPanel = drawPanel;

		yoffset = 40; r=30; i=0; j=0;

        	center = new Cord(x/2,y/2);

        	atomCount=25;  	 

        	atom = new Vector(25,1);

        	Pos = new Vector(25,1);

        	for(int count=0;count<atomCount;count++)

        		atom.addElement( new Atom(drawPanel,count,x,y) );

        	g = drawPanel.getGraphics();

        	bonds = new Vector(25,2);

        	bondCount=25;

        	for(int count=0;count<bondCount;count++)

        		bonds.addElement( new MyBond("Single Bond",x,y));

	

        }	

	

	public void MyDrawMolecule(String Molecule)

        {

        	double Value1,Value2,Value3,rmax = 100,dist;

        	String Value0;

        	i=0;j=0;

        	String s;

        	this.Molecule = Molecule;

        	atomCount=0;

        	bondCount=0;

		g = drawPanel.getGraphics();

      		try{

      			FileReader fr = new FileReader("MV\\Models\\"+Molecule+".xyz");

      			BufferedReader br = new BufferedReader(fr);

      			check = true;

      			do{ 

      				s = br.readLine();

      				if( s==null ) break;

      				Value0 = s;

      				Value1 = Double.parseDouble(br.readLine());

      				Value2 = Double.parseDouble(br.readLine());

      				Value3 = Double.parseDouble(br.readLine()); 

      				dist = Math.sqrt(Value1*Value1 + Value2*Value2 + Value3*Value3);

      				if( dist > rmax  )

      					 rmax = dist; 					

      			}

      			while( s!= null );

      			fr.close();

      			

      			fr = new FileReader("MV\\Models\\"+Molecule+".xyz");

      			br = new BufferedReader(fr);

      			

      			myImage = drawPanel.createImage(x-20,y-yoffset-70);

      			newG = myImage.getGraphics();

      			newG.setColor(Color.black);

      			newG.fillRect(0,0,x-20,y-yoffset-70);

      			

      			do{

      				s = br.readLine();

      				if( s==null ) break;

      				Value0 = s;

      				Value1 = Double.parseDouble(br.readLine());

      				Value2 = Double.parseDouble(br.readLine());

      				Value3 = Double.parseDouble(br.readLine());

      				temp = (Atom)atom.elementAt(atomCount);

      				atomCount++;

      				temp.InitAtom(Value0,Value1,Value2,Value3,rmax,newG);

      				atom.setElementAt(temp,atomCount-1);	

      			}while( s!=null );		

      			fr.close();

      			

      			try

      			{

      				fr = new FileReader("MV\\Bonds\\"+Molecule+".xyz");

      				 br = new BufferedReader(fr);

      				int atom1,atom2;

      				while( (s=br.readLine())!=null && !s.equals("\n") )

      				{

      					myBond = (MyBond)(bonds.elementAt(bondCount++));

      					myBond.setType( s.trim() );

      					myBond.setAtom1( (Atom)atom.elementAt(Integer.parseInt( br.readLine())-1) );

      					myBond.setAtom2( (Atom)atom.elementAt(Integer.parseInt( br.readLine())-1) );

      					myBond.setGraphics(newG);

      				}

      				fr.close();

      			}catch(Exception e){}

      			

      			sortZ();

      			

      			int i=0;

      			while(i<bondCount)

      				((MyBond)(bonds.elementAt(i++))).Draw();

      			      			

      			for(count=0;count<atomCount;count++)

      			{

      				temp = (Atom)atom.elementAt(count);

      				/*	

     					if(  check && ( temp.getZ() > -temp.getR() ) )

      				{	check = false; 

      					newG.setColor(Color.yellow);

        					newG.drawLine(20,center.y-yoffset-20,x-40,center.y-yoffset-20);

        					newG.drawLine(x/2,0,x/2,y-yoffset-70);					        	

					} 

					 */    				

      				temp.Draw(0);

      			}

      	    			

      			g.drawImage(myImage,0,0,null);

      		}catch(Exception e){System.out.println(Molecule+".xyz File not found");}

			

		rMax=0;

		for(int i=0;i<atom.size();i++)

		{

			Atom myatom = (Atom)atom.elementAt(i);

			int tempx = myatom.getX(); 

			int tempy = myatom.getY(); 

			int tempz = myatom.getZ();

			int distance = (int)Math.sqrt(tempx*tempx+tempy*tempy+tempz*tempz);

			if( rMax < distance ) rMax = distance;

		}



		return;

        }	

			

        public void rotateY()

        {

        	sortZ(); check = true;

        	int i=0;

        	newG.setColor(Color.black);

        	newG.fillRect(x/2-rMax-30,y/2-yoffset-60-rMax,2*rMax+60,2*rMax+60);

		

		for(int count=0;count<atomCount;count++)

		{

			temp = (Atom)atom.elementAt(count);		

			temp.RotateY();

        	}

		/*

		newG.setColor(Color.yellow);

     		newG.drawLine(20,center.y-20-yoffset,x-40,center.y-20-yoffset);

        	newG.drawLine(x/2,0,x/2,y-yoffset-70);					        

		*/

		i=0;

		while(i<bondCount)

      			((MyBond)(bonds.elementAt(i++))).Draw();

		

		for(int count=0; count < atomCount ; count++ )

        	{

        		temp = (Atom)atom.elementAt(count);

        		/*

			if( check && temp.getZ() > -temp.getR() )

        		{  	check = false; 

        			newG.setColor(Color.yellow);

        				newG.drawLine(20,center.y-yoffset-20,x-40,center.y-20-yoffset);

        				newG.drawLine(x/2,0,x/2,y-yoffset-70);					        

        		} 

			*/

        		temp.Draw(0);        		

        	}

		

        	g.drawImage(myImage,0,0,null);

        }

        

        public void rotateX()

        {   

		sortZ();  check = true;	

        	int i=0;

        	newG.setColor(Color.black);

        	newG.fillRect(x/2-rMax-30,y/2-yoffset-60-rMax,2*rMax+60,2*rMax+60);

		

		for(int count=0;count<atomCount;count++)

		{

			temp = (Atom)atom.elementAt(count);		

			temp.RotateX();

        	}

		/*

		newG.setColor(Color.yellow);

     		newG.drawLine(20,center.y-20-yoffset,x-40,center.y-20-yoffset);

        	newG.drawLine(x/2,0,x/2,y-yoffset-70);					        

		*/

		i=0;

		while(i<bondCount)

      			((MyBond)(bonds.elementAt(i++))).Draw();



		for( int count=0; count < atomCount ; count++ )

        	{

        		temp = (Atom)atom.elementAt(count);

        		/*

			if( check && temp.getZ() > -temp.getR() )

        		{  	check = false; 

        		      newG.setColor(Color.yellow);

        				newG.drawLine(20,center.y-yoffset-20,x-40,center.y-yoffset-20);

        				newG.drawLine(x/2,0,x/2,y-yoffset-70);					        

        		}

			*/

			temp.Draw(2);     	

        	}

        	g.drawImage(myImage,0,0,null);

        }

        

        public void rotateZ()

        {

        	check = true;

		newG.setColor(Color.black);

        	newG.fillRect(x/2-rMax-30,y/2-yoffset-60-rMax,2*rMax+60,2*rMax+60);

		

		int i=0;

		for(int count=0;count<atomCount;count++)

		{

			temp = (Atom)atom.elementAt(count);		

			temp.RotateZ();

        	}

		/*

		newG.setColor(Color.yellow);

     		newG.drawLine(20,center.y-20-yoffset,x-40,center.y-20-yoffset);

        	newG.drawLine(x/2,0,x/2,y-yoffset-70);					        				

		*/

		while(i<bondCount)

      			((MyBond)(bonds.elementAt(i++))).Draw();

        	

        	for(int count=0; count < atomCount ; count++ )

        	{	

        		temp = (Atom)atom.elementAt(count);   

	        	/*	

			if( check && temp.getZ() <= -temp.getR() )

        		{	check = false; 

				newG.setColor(Color.yellow);

        			newG.drawLine(20,center.y-20-yoffset,x-40,center.y-20-yoffset);

        			newG.drawLine(x/2,0,x/2,y-yoffset-70);					        

        		} 

			*/

        		temp.Draw(3);        		

        	}

        	g.drawImage(myImage,0,0,null);

        }

        

        public void reSet()

        {

        	i=0;j=0;

        }	

        

        // Ascending order.

        public void sortZ()

        {

        	Atom temp;

        	for( int ii=0;ii<atomCount;ii++ )

        		for( int jj=ii+1;jj<atomCount;jj++ )

        		{

        			if( ((Atom)atom.elementAt(ii)).getZ() > ((Atom)atom.elementAt(jj)).getZ() )

        			{

        				temp = (Atom)atom.elementAt(ii);

        			 	atom.setElementAt( atom.elementAt(jj),ii );

        			 	atom.setElementAt( temp,jj );

        			}

        		}	

        }

        

        public void correctPos()

        {

        	for(int ii=0;ii<atomCount;ii++)

        		((Atom)atom.elementAt(ii)).correctPos();

        }

		       

}        

