package MV;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;

import java.awt.event.*;

import java.io.*;

import java.util.*;

import javax.swing.JDialog.*;

import javax.swing.border.*;

import java.lang.*;



public class MainPanel extends JPanel implements ActionListener,ItemListener

{

  Choice Molecule;

  JButton RESET, DELETE, EXIT, ADD, RotateX, RotateY, RotateZ;

  Viewer viewer;

  JDialog Add;

  JTextField textfield;

  MyDrawPanel drawpanel;

  String molecule;

  int count,Deg;

  JLabel rotate,deg;

  int x,y;

     

  public MainPanel(Viewer viewer,MyDrawPanel drawpanel,int x,int y)

  {	

    this.x = x;

	this.y =y;

	 setPreferredSize( new Dimension(x,y-40));	

     this.viewer = viewer;	   

     this.drawpanel = drawpanel; 

     Box box = Box.createVerticalBox(); 

     JPanel jp = new JPanel();

     jp.setSize(x-20,70);

     Box box1 = Box.createHorizontalBox();

     JLabel inputlabel = new JLabel("Choose the Molecule   ",Label.RIGHT);

     inputlabel.setFont( new Font("Sanserif",Font.BOLD,16) );

     inputlabel.setForeground(Color.blue);

     box1.add(inputlabel);

     box1.add(Box.createHorizontalGlue());

     Molecule = new Choice();

     

     Vector MoleculeName = new Vector(20,2);

     try{

     String s;

     FileReader fr = new FileReader("MV\\MoleculeList.txt");

     BufferedReader br = new BufferedReader(fr);

     while( (s=br.readLine())!=null && !s.equals("\n") && !s.equals("") ) 			

     {  

     	MoleculeName.add(s);   	

     }

     fr.close();

     }catch(Exception e){}

     int i=0;

  

     Object[] mn =  MoleculeName.toArray();

     String[] MN = new String[mn.length];

     for( int ii=0;	ii<mn.length;	ii++ )

     		MN[ii] = mn[ii].toString();

     MN = Sort(MN);		

     

     try{

     FileWriter fr = new FileWriter("MV\\MoleculeList.txt");

     i=0;

     while( i<MN.length )

     {		fr.write(  MN[i]+"\n" );

     		Molecule.add( MN[i]);

     		i++;

     }			

     

     fr.close();

     }catch(Exception e){}

     

     Molecule.select("Ammonia");

     Molecule.addItemListener(this);

     box1.add(Molecule);

     

     jp.add(box1);

     box.add(jp);

     box.add(Box.createVerticalGlue());

     

     jp = new JPanel();

     jp.setPreferredSize(new Dimension(x-20,y-150));

     jp.setBackground(Color.black);

     jp.setForeground(Color.white);

     TitledBorder tb1 = new TitledBorder( new LineBorder(Color.black),"");

     tb1.setTitleColor(Color.blue);

     jp.setBorder(tb1);   

     jp.add(drawpanel);

     box.add(jp); 

     

     textfield = new JTextField(3); 

     jp = new JPanel();

     jp.setPreferredSize( new Dimension(x-20,70) );

     jp.setVisible(true);

     box1 = Box.createHorizontalBox();

     RESET = new JButton("RESET");

     ADD = new JButton("ADD");

     EXIT = new JButton("EXIT");

     DELETE = new JButton("DELETE");

     RotateX = new JButton("RotateX");

     RotateY = new JButton("RotateY");

     RotateZ = new JButton("RotateZ");

     Box box2 = Box.createHorizontalBox();

     box2.add(RotateX); box2.add(Box.createHorizontalGlue());  

     box2.add(RotateY); box2.add(Box.createHorizontalGlue());

     box2.add(RotateZ); 

     rotate = new JLabel("   Rotate by");

     box2.add(rotate);  box2.add(Box.createHorizontalGlue());

     box2.add(textfield);

     textfield.setText("180");

     textfield.addActionListener(this);

     deg = new JLabel("Degrees");

     box2.add(deg);     box2.add(Box.createHorizontalGlue());

     box1.add(RESET);  box1.add(Box.createHorizontalGlue());

     box1.add(ADD);    box1.add(Box.createHorizontalGlue());  

     box1.add(DELETE); box1.add(Box.createHorizontalGlue()); 

     box1.add(EXIT);    

     Box box3 = Box.createVerticalBox();

     box3.add(box2); box3.add(Box.createVerticalGlue());

     box3.add(box1); 

     jp.add(box3);    

     box.add(jp);

     RESET.addActionListener(this);

     ADD.addActionListener(this); 

     DELETE.addActionListener(this);

     EXIT.addActionListener(this);

     RotateX.addActionListener(this);

     RotateY.addActionListener(this);	

     RotateZ.addActionListener(this);

     add(box);    

     /*

     molecule = Molecule.getSelectedItem();

        drawpanel.setMolecule(molecule);

        drawpanel.reSet();

        drawpanel.paint(this.getGraphics()); 

     */

	//ImageIcon myImage =   new ImageIcon("MV\\molecule.jpg");

	//setBackgroundImage( myImage );

  }

  

  public void setNewMoleculeName( String n )

  {

  	Molecule.add( n );

  }	

  

  public void actionPerformed( ActionEvent ae )

  {

  	 String command = (String)ae.getActionCommand();

         

         if( command.equals("ADD") )

         {      

         	NewMolecule nm = new NewMolecule(this);

		return;

         }

         

         if( command.equals("DELETE") )

         {

         	String eraseMolecule = Molecule.getSelectedItem();

         	String data = 	"Do you want to delete this molecule : "+eraseMolecule+" ?";

         	MyDialog md = new MyDialog(viewer,data,true);

   		

         	if( (md.getAction()).equals("Yes") )

         	{

         		Molecule.remove(eraseMolecule);

         		String s;

         		try

         		{

         			Vector V = new Vector(20,2);

         			FileReader fr = new FileReader("MV\\MoleculeList.txt");

         			BufferedReader br = new BufferedReader(fr);

         			while( (s=br.readLine())!=null && !s.equals("\n") && s!="" )

         			{

         				if( !s.equals(eraseMolecule.trim()) )

         					V.addElement(s);

         			}

         			fr.close();

         			FileWriter fw = new FileWriter("MV\\MoleculeList.txt",false);

         			int i=0;

         			while( i<V.size() )

         				fw.write( (String)(V.elementAt(i++))+"\n");

         			fw.close();

         			

         			File f = new File("MV\\Models\\"+eraseMolecule+".xyz");

         			f.delete();

         			

         			drawpanel.Clear(this.getGraphics());

         			

         		}catch(Exception e){ System.out.println("Error ! Cant save to file."); }

         			

            	}

            	return;					 

         }

         

         if( command.equals("EXIT") )

         {

         	System.exit(0);	

         }

         

         if( command.equals("RotateY") )

         {         	

         	count = 0;

         	Deg = 10*Integer.parseInt(textfield.getText())/9;

         	while( count++ < Deg )

         	{

        		if(count%5==0)	drawpanel.correctPos();

        		drawpanel.rotateY();

        	}

         	return;

         }	

         

         if( command.equals("RotateX") )

         {

         	count = 0;

         	Deg = 10*Integer.parseInt(textfield.getText())/9;

         	while( count++ < Deg )

         	{	

        	        if(count%5==0)	drawpanel.correctPos();	

        		drawpanel.rotateX();

        	}

        	return;

         }

         

         if( command.equals("RotateZ") )

         {

         	count = 0;

         	Deg = 10*Integer.parseInt(textfield.getText())/9;

         	while( count++ < Deg )

         	{

        		drawpanel.rotateZ();

        		if(count%5==0)

        			drawpanel.correctPos();

        	}

        	return;

        }

         

         if(command.equals("RESET"))

         {

         	drawpanel.paint(this.getGraphics());

         	textfield.setText("180");

         }	

  }

  

  public void itemStateChanged(ItemEvent ie)

  {

  	molecule = Molecule.getSelectedItem();

        drawpanel.setMolecule(molecule);

        drawpanel.reSet();

        drawpanel.paint(drawpanel.getGraphics());

  }

  

  public String[] Sort( String[] N )

  {

  	String s,ss;

  	int n = N.length;

  	for(int i=0;i<n;i++)

  	{

  		s = N[i];

  		for(int j=i+1;j<n;j++)

  		{

  			ss = N[j];

  			if( s.compareToIgnoreCase(ss) > 0 )

  			{

  				String temp = N[i];

  				N[i]=N[j];

  				N[j]=temp;

 			}				

  		}

  	}

  	return N;

  }			

        

}           



class MyDialog extends JDialog implements ActionListener

{

	String action;

	public MyDialog( JFrame jf, String data, boolean state)

	{

		super(jf,data,state);

		setSize(new Dimension(360,90) );

		action = "";

		JButton Yes = new JButton("Yes");

  		JButton No  = new JButton("No");

  		Yes.addActionListener(this);

  		No.addActionListener(this);

  		Box b = Box.createVerticalBox();

  		b.add(new JLabel(data));

  		Box subbox = Box.createHorizontalBox();

  		subbox.add(Box.createHorizontalGlue());

  		subbox.add(No); subbox.add(Box.createHorizontalGlue());	subbox.add(Yes);

  		subbox.add(Box.createHorizontalGlue());

  		b.add(Box.createVerticalGlue());

  		b.add(subbox);

  		getContentPane().add(b);

  		setVisible(true);

	}

	

	public void actionPerformed(ActionEvent ae)

	{

		String com = ae.getActionCommand();

		if( com.equals("Yes") )

			action = "Yes";

		else action = "No";	

		dispose();	

	}

	

	public String getAction(){	return action;	}

}	

		