package MV;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;

import java.awt.event.*;

import java.io.*;

import java.util.*;

import javax.swing.JDialog.*;

import javax.swing.border.*;

import java.lang.*;



public class MyBond

{

	String type;

	Atom Atom1;

	Atom Atom2;	

	int yoffset,x,y;

	Graphics2D g;

	Polygon poly;

	

	MyBond( String type,int x,int y )

	{

		this.x = x;

		this.y = y;

		yoffset = 40;

		this.type = type;

	}	

	

	MyBond( String type, Atom Atom1, Atom Atom2  )

	{

		this.type = type;

		this.Atom1 = Atom1;

		this.Atom2 = Atom2;

	}



	public void setGraphics(Graphics g)

	{

		this.g =(Graphics2D)g;

	}

	

	public void setAtom1(Atom Atom1)

	{

		this.Atom1 = Atom1; 

	}

	

	public void setAtom2(Atom Atom2)

	{

		this.Atom2 = Atom2;

	}

		

	public Atom getAtom1()

	{

		return Atom1;

	}

	

	public Atom getAtom2()

	{

		return Atom2;

	}		

	

	public void Draw()

	{	

		//Graphics2D g = (Graphics2D)G;

		int dx,x1 = Atom1.getX()+x/2 , x2 = Atom2.getX()+x/2;

		int dy,y1 = Atom1.getY()+y/2-yoffset-30 , y2 = Atom2.getY()+y/2-yoffset-30; 

		

		if( type.equals("Single Bond") )

		{	g.setColor(Color.white);

			g.drawLine( x1,y1,x2,y2);

		}

		else if( type.equals("Double Bond") )

		{	g.setColor(Color.white);

			if( (x1!=x2) && ( Math.abs((y2-y1)/(x2-x1))>1 ) ) 

			{	g.drawLine( x1-4,y1,x2-4,y2 );

				g.drawLine( x1+4,y1,x2+4,y2);

			}

			else

			{	g.drawLine( x1,y1-4,x2,y2-4 );

				g.drawLine( x1,y1+4,x2,y2+4);

			}

		}

		else 

		{	g.setColor(Color.blue);

			g.drawLine( x1-2,y1,x2-2,y2);

			g.drawLine( x1,y1,x2,y2 );

			g.drawLine( x1+2,y1,x2+2,y2);

		}		

		//g.setColor(c);

		/*

		int z = Atom1.getZ()>Atom2.getZ() ? Atom1.getZ() : Atom2.getZ();

		double t = 10/(2 - z/250); 

		double slope,theta;

		

		int[] xarray = new int[4];

		int[] yarray = new int[4];

		

		if( Atom1.gettx()==Atom2.gettx() )

		{	dx = 5;	dy =0;	}			

		else

		{

			slope = (Atom1.getty()-Atom2.getty())/(Atom1.gettx()-Atom2.gettx());

			theta = Math.atan(slope);

			dx = -(int)( Math.sin(theta)*t ); 

			dy = (int)(Math.cos(theta)*t );

		}

			

			

		xarray[0] = x1-dx; xarray[1]=x1+dx; xarray[3]=x2-dx; xarray[2]=x2+dx;

		yarray[0]=y1-dy; yarray[1]=y1+dy; yarray[3]=y2-dy; yarray[2]=y2+dy;

		*/

		/*

		GradientPaint redtowhite = new GradientPaint(x1,y1,c,x2,y2,Color.white);

        	g.setPaint(redtowhite);

        	*/

        	/*

		poly = new Polygon(xarray,yarray,4);

		g.fillPolygon(poly);

		*/

	

	}



	public void Clear()

	{

		g.setColor(Color.black);

		g.fillPolygon(poly);

	}



	public String getType()

	{

		return type; 

	}

	

	public void setType( String t )

	{

		type = t;

	}		

	

}		