package MV;

import java.awt.event.*;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;



public class Viewer extends JFrame 

{

  MyMenuBar thismenubar;

  MainPanel mainpanel;

  MyDrawPanel drawPanel;

  JWindow splashScreen;

  JLabel splashLabel;

  

  public Viewer( String title )

  {

  	Rectangle screenRect = getGraphicsConfiguration().getBounds();  

	setTitle("Loading... Please wait");

	ImageIcon myImage =   new ImageIcon("MV\\molecule.jpg");

	splashLabel = new JLabel("MOLECULE",myImage,JLabel.CENTER);

	// splashLabel.setVerticalTextPosition( JLabel.BOTTOM );

	

	splashScreen = new JWindow();

	Box vbox = Box.createVerticalBox();

	vbox.add(splashLabel, BorderLayout.CENTER);

	vbox.createVerticalGlue();

	JTextField text = new JTextField("      Molecule Viewer    \n") ;

	text.setEditable(false);

	text.setBackground( Color.white );

	text.setFont( new Font( "Dialog", Font.BOLD|Font.ITALIC, 30 ));

	vbox.add(text);

	splashScreen.getContentPane().add( vbox );

	splashScreen.pack();

	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

	splashScreen.setSize( new Dimension( 330,468 )); 

	splashScreen.setLocation(screenSize.width/2 - splashScreen.getSize().width/2,

				     screenSize.height/2 - splashScreen.getSize().height/2);

	 // 332,428

 	// splashScreen.add(splashLabel, BorderLayout.CENTER);

 	

 	SwingUtilities.invokeLater(new Runnable() {

	    public void run() {

		showSplashScreen();

	    }

	});

 	try{

 	Thread.sleep(5000);

	}catch(Exception e){}

  	thismenubar = new MyMenuBar();

        setJMenuBar(thismenubar);

        drawPanel = new MyDrawPanel(this,"",screenRect.getSize().width,screenRect.getSize().height);

        mainpanel = new MainPanel(this,drawPanel,screenRect.getSize().width-10,screenRect.getSize().height-10);

        getContentPane().add( mainpanel );

        setTitle(title);

        SwingUtilities.invokeLater(new Runnable() {

	    public void run() {

		hideSplashScreen();

	    }

	});

  }

 

  public void showSplashScreen()

  {

  	splashScreen.show();

  }	

  

  public void hideSplashScreen()

  {

  	splashScreen.setVisible(false);

	splashScreen = null;

	splashLabel =null;

   } 			

  	

}  	  	

