package MV;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;

import java.awt.event.*;

import java.io.*;

import java.util.*;

import javax.swing.border.*;

import java.lang.*;



public class Atom

{

	Graphics g;

	int radius = 50, color_var,x,y,z,R,yoffset;

	double rmax;

	double tx,ty,tz,t,distance;

	Cord center;

	String A;

	MyDrawPanel drawPanel;

	int atomNo,Cx,Cy;

	

	public Atom( MyDrawPanel drawPanel ,int atomNo,int Cx,int Cy )

	{

		this.Cx = Cx;

		this.Cy = Cy;

		this.drawPanel = drawPanel;

		yoffset=40;

		t=Math.PI/200;

		this.atomNo=atomNo;

		center = new Cord(Cx/2,Cy/2);	

				

	}	

		 

	// The (r,t,p) is the view box. In a 200*200*200 box around origin. 

	public void InitAtom(String A,double tx,double ty,double tz,double rmax,Graphics g)

	{

		this.tx = tx;

		this.ty = ty;

		this.tz = tz;

		this.A = A;

		this.rmax = rmax;

		distance = Math.sqrt(tx*tx+ty*ty+tz*tz);

		this.g = g;	

	}

	

	public void Draw(int select)

	{

		/*

		try{

		tx = Cx*tx/(Cx-z);

		ty = Cx*ty/(Cx-z);

		}catch(Exception e){}

		*/

		x = (int)tx; y = (int)ty; z = (int)tz;

		

		try{

		//	R = (int)( rmax*radius / ( 2*rmax - z ) );

			R = (int)( Cx/2*radius/( Cx - z ));			

		}catch(Exception e){}

		

		if( A.equals("H") )	R = (int)(0.7*R);

		int xx = center.x+x , yy = center.y-30-yoffset+y;	

			

		for( int temp=R; temp>=0; temp-=1 )

		{	

			color_var =  (int)(255*Math.pow( Math.cos(temp*Math.PI/(2*R)),4) );			

			g.setColor( ColorChooser(A));

			g.fillOval(xx-temp,yy-temp,2*temp,2*temp);			

		}

		

		g.setColor(Color.black);

		g.setFont( new Font("Dialog",Font.BOLD,12));

		g.drawString(A+"",xx-R/3-6,yy+R/3+6);

		

	}



	public void RotateY()

	{

			tx = tx*Math.cos(t) - tz*Math.sin(t);

			tz = tz*Math.cos(t) + tx*Math.sin(t);

			//Clear();		

	}



	public void RotateX()

	{

			ty = ty*Math.cos(t) - tz*Math.sin(t);

			tz = tz*Math.cos(t) + ty*Math.sin(t);

			//Clear();

	}



	public void RotateZ()

	{

			ty = ty*Math.cos(t) - tx*Math.sin(t);

			tx = tx*Math.cos(t) + ty*Math.sin(t);

			//Clear();

	}



	public void Clear()

	{

		g.setColor(Color.black);

		g.fillOval(x-R+center.x,y-R+center.y-yoffset-30,2*R,2*R);	

	}

	

	public Color ColorChooser(String A)

	{

			if( A.equals("H") ) return new Color(color_var/2+127,color_var/2+127,color_var);

			if( A.equals("C") ) return new Color(color_var,color_var/2+127,color_var/2+127); 

			if( A.equals("N") ) return new Color(color_var/2+127,color_var,color_var/2+127);

			if( A.equals("O") ) return new Color(color_var/2+127,color_var,color_var);

			if( A.equals("S") ) return new Color(color_var,color_var/2+127,color_var);

			if( A.equals("K") ) return new Color(color_var,color_var,color_var/2+127);

			if( A.equals("Cl") || A.equals("Br") || A.equals("I") || A.equals("F") ) return new Color(127+color_var/2,127+color_var/2,127+color_var/2);

			return new Color(color_var,color_var,color_var);		

        }

        

        public int getZ()

        {

        	return (z=(int)tz);

        }	

        

        public int getX()

        {

        	return (x=(int)tx);

        }

        

        public int getY()

        {

        	return (y=(int)ty);

        }	

        

        public double gettx(){	return tx;}

        

        public double getty(){	return ty;}	

        

        public int getR()

        {

        	return (int)( rmax*radius / ( rmax - (int)tz ) );        	

        }	

        

        public void correctPos()

        {

        	double d ;

        	try{

        		d = distance/Math.sqrt(tx*tx+ty*ty+tz*tz);

        	}catch(Exception e){ d = 1; } 

        	tx = tx*d;

        	ty = ty*d;

        	tz = tz*d;

        }	

        

}        