package MV;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;

import java.awt.event.*;

import java.io.*;

import java.util.*;

import javax.swing.border.*;

import java.lang.*;



public class DrawAtom

{

	Graphics g;

	int r = 20, color_var;

	Cord center;

	Color color;

	

	// The (r,t,p) is the view box. In a 200*200*200 box around origin. 

	public DrawAtom(String A,double r,double t,double p,MyDrawPanel drawPanel)

	{

		g = drawPanel.getGraphics();

		int x =  center.x + (int)(r*Math.cos(t)*Math.cos(p)); 

		int y =  center.y + (int)(r*Math.sin(t)*Math.cos(p));

		int z = (int)(r*Math.sin(p));

		int R = (int)( 10*r / (10+z/40) );

		

		for( int i=R; i>=0; i-- )

		{

			color_var = 100 + (int)(155*Math.pow( Math.cos(i*Math.PI/(2*R)),2) );

			color = ColorChooser(A);

			g.setColor(color);

			g.fillOval(x-i,y-i,2*i,2*i);

			

		}

		g.setColor(Color.black);

		g.drawString(A+"",x-R/3,y+R/3);

	}

	

	public Color ColorChooser(String A)

	{

	

			if( A.equals("O") ) return new Color(color_var,100,100);

			if( A.equals("C") ) return new Color(100,color_var,100);

			if( A.equals("N") ) return new Color(100,100,color_var);

			if( A.equals("H") ) return new Color(100,color_var,color_var);

			if( A.equals("S") ) return new Color(color_var,100,color_var);

			if( A.equals("K") ) return new Color(color_var,color_var,100);

			if( A.equals("Cl") || A.equals("Br") || A.equals("I") || A.equals("F") ) return new Color(100,color_var,color_var);

			return new Color(color_var,color_var,color_var);

		

        }

        

        

        

        public void DrawBond( double x1,double y1, double x2,double y2 )

        {

        	int x_1 = center.x + (int)(40*x1);

        	int x_2 = center.x + (int)(40*x2);

        	int y_1 = center.y + (int)(40*y1);

        	int y_2 = center.y + (int)(40*y2);

        	g.setColor(Color.yellow);

        	g.drawLine(x_1,y_1,x_2,y_2);

        }

        

}        