package MV;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;

import java.awt.event.*;

import java.io.*;

import java.util.*;

import javax.swing.border.*;

import java.lang.*;



public class MyDrawPanel extends JPanel

{

	Viewer myViewer;

	Image img;

	String Molecule;

	boolean show;

	int yoffset,r,color_var,x,y;

	Cord center;

	Font f;

	Color color;

	Graphics g;

	DrawMolecule drawMolecule;



	public MyDrawPanel(Viewer myViewer,String Molecule,int x,int y)

	{		

		this.x=x;

		this.y=y;

		this.myViewer = myViewer;

		this.Molecule = Molecule;

		drawMolecule = new DrawMolecule(this,Molecule,x,y);				

		center = new Cord(x/2,y/2);

		yoffset=40;

		setPreferredSize(new Dimension(x-20,y-yoffset-106));

		TitledBorder tb1 = new TitledBorder( new LineBorder(Color.black),"");

                tb1.setTitleColor(Color.blue);

                setBorder(tb1);   	        

		show = false;

		r = 40; color_var = 0;

		f = new Font("Dialog",Font.BOLD,r );

		setFont(f); 

	}

	

	public void setMolecule(String molecule)

	{

		Molecule = molecule;

		show = true; 

	}

		

	public void paint(Graphics g)

	{	

		this.g = g;

		if( show == true)

		{

			// To redraw the screen.

			g.setColor(Color.black);

			g.fillRect(10,yoffset,x-20,y-yoffset-122);

			

			// Start molecule; 

			drawMolecule.MyDrawMolecule(Molecule);		        

		}			

	}

	

	public void Clear(Graphics g)

	{

		this.g = g;

		g.setColor(Color.black);

		g.fillRect(10,yoffset,x-20,y-yoffset-120);

	}	

	

	public void correctPos()

	{

		drawMolecule.correctPos();

	}	

	

	public void rotateY()

	{

		drawMolecule.rotateY();

	}	

	

	public void rotateX()

	{

		drawMolecule.rotateX();

	}

	

	public void rotateZ()

	{

		drawMolecule.rotateZ();

	}

	

	public void reSet()

	{

		drawMolecule.reSet();

	}



}	

			