package MV;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;

import java.awt.event.*;

import java.io.*;

import java.util.*;

import javax.swing.JDialog.*;

import javax.swing.border.*;

import java.lang.*;



public class NewAtom

{

	int x,y,atom_no,VE;

	String atomName;

	boolean mobile,visited;

	Color c;

	Vector Neighbour;

	double PVx,PVy,PVz;

	double CordX,CordY,CordZ;	

	int no_SB,no_DB,no_TB;



	NewAtom( int x,int y, String atomName, int atom_no )

	{

		this.x = x;

		this.y = y;

		this.atomName = atomName;

		this.atom_no = atom_no;

		mobile = true;

		Neighbour = new Vector(6,1);

		visited = false;

		no_SB=0;no_DB=0;no_TB=0;

		setVE();



	}

	

	public int getVE()

	{

		return VE;		

	}

	

	public int getSB(){	return no_SB;	}

	

	public int getDB(){	return no_DB;	}

	

	public int getTB(){	return no_TB;	}

	

	public void setVE()

	{

		if( atomName.equals("C") )	VE=4;

		else if( atomName.equals("H") )	VE=1;

		else if( atomName.equals("O") )	VE=6;

		else if( atomName.equals("N") )	VE=5;

		else if( atomName.equals("S") ) VE=6;

		else if( atomName.equals("P") ) VE=5;

		else if( atomName.equals("Cl") || atomName.equals("Br") || atomName.equals("I") || atomName.equals("F") ) VE=7;

		else if( atomName.equals("Xe") ) VE=8;

		return;

	}	

	

	public int getX()

	{

		return x;

	}

	

	public int getY()

	{

		return y;

	}

	

	public void setMovable( boolean mobile )

	{

		this.mobile = mobile;

	}	

	

	public String getAtomName()

	{

		return atomName;

	}

	

	public int getAtom_no()

	{

		return atom_no;

	}	

	

	public void setX(int xx)

	{

		if(mobile)

		x = xx;

	}

	

	public void setY(int yy)

	{

		if(mobile)

		y = yy;

	}

	

	public void Clear( Graphics g ) 		

	{

		g.setColor(Color.black);

		g.fillOval(x-10,y-10,20,20);

	}

	

	public void Draw( Graphics g , Color color)

	{

		g.setColor(color);

		c = color;

		g.fillOval(x-10,y-10,20,20);

		g.setColor(Color.black);

		g.drawString(atomName,x-5,y+5);	

	}	

	

	public Color getcolor()

	{

		return c;

	}

	

	public void BondedNeighbour(NewAtom na,String bond)

	{

		if(bond.equals("Single Bond"))	no_SB++;

		else if(bond.equals("Double Bond"))	no_DB++;

		else if(bond.equals("Triple Bond"))	no_TB++;

		Neighbour.addElement(na);

	}

	

	public Vector getNeighbours()

	{

		return Neighbour;

	}			

		

	public void setVisited( boolean state )

	{

		visited = state;

	}



	public boolean getVisited()

	{	return visited; 	}



	public double getPVx()

	{   return PVx;  }



	public double getPVy()

	{   return PVy;  }



	public double getPVz()

	{   return PVz;  }



	public void setPVx(double value)

	{   PVx = value; }



	public void setPVy(double value)

	{   PVy = value;   }



	public void setPVz( double value )

	{	PVz = value;	}



	public void setCord( double x,double y,double z )

	{	CordX=x;	CordY=y;	CordZ=z;	}



	public double getCordX(){	return CordX;	}



	public double getCordY(){	return CordY;	}



	public double getCordZ(){	return CordZ;	}



}				

