package MV;

import javax.swing.*;

import javax.swing.event.*;

import java.awt.*;

import java.awt.event.*;

import javax.swing.border.*;



public class ShowFile extends JFrame implements ActionListener

{

	String label;

	public ShowFile(String label)

	{

	   this.label = label;

	   setSize( new Dimension(500,500) );

	   setTitle("   Inside help   ");

	   JButton OK = new JButton("OK");

	   OK.addActionListener(this);

	   Box box = Box.createVerticalBox();

	   JPanel jp = new JPanel();



	   jp.setLayout( new BoxLayout(jp, BoxLayout.X_AXIS)) ;	   

	   TitledBorder tb1 = new TitledBorder( new LineBorder(Color.black),"");

           tb1.setTitleColor(Color.blue);

           jp.setBorder(tb1);   

	   setDefaultCloseOperation( WindowConstants.DISPOSE_ON_CLOSE );

	   JTextArea text = new JTextArea();

	   text.setEditable(false);

	   text.setLineWrap(true);

	   text.setFont( new Font("Dialog", Font.PLAIN,18 ));

	   text.setTabSize(5);

	   text.setText(getText(label) );

	   jp.add(text);

	   jp.setSize( new Dimension(500,450));

	   

	   box.add(jp);

	   box.add(Box.createVerticalGlue() );

	   box.add(OK);

	   getContentPane().add(box);

	   setVisible(true);

	}

	

	public void actionPerformed( ActionEvent ae )

	{

		dispose();

	}

	

	public String getText( String text )

	{

		String readtext;

		if(text.equals("About") )

		{

			readtext = " This is a 3D Molecule Viewer and Creator program.\n"+

				   " It can be used to create 3D molecules as well as view them"+

				   " \n\n  Creator :\n Kumar Gaurav"+

				   " \n Computer Science,\n IIT Kanpur,\n India."+

				   " \n email: kgaurav@iitk.ac.in , kgaurav@cse.iitk.ac.in"+

				   " \n\n See also Help for more Information."+

				   " \n\n Thanks for using this product.";					

		}

		else 

		{	

			readtext = " To get a 3D view of a Molecule, check if its in the list."+

				   "\n If its there, just click on it and rotate it by the desired"+

				   "\n degrees in any of the 3 axes. You may delete this molecule."+

				   "\n In order to create your own molecule, click on the ADD "+

				   "\n button. You will see that another window opens up. "+

				   "\n Now choose the appropiate atoms one by one and set their"+

				   "\n positions onto the screen by dragging. Now its time to "+

				   "\n fill the bonds. click on the AddBond list, click on the "+

				   "\n first atom, then click on the second atom. In this way a "+

				   "\n planar 2D view will be created. Now save the molecule and"+

				   "\n exit from this panel to return back to the original window"+

				   "\n Your molecule has now been added to the list.";    

		}

		return readtext;

	}

	

}	

	

		

		

		

		

	   

	